
	program RmWmGraf
!---------------------------------------------------------------!
!	Program name: RMWMGRAF 					!
!	Written by: H.E. WIlloughby AOML/HRD			!
!	Latest update:	30JUL13	by:	RWJ			!
!	Function: Uses trakXXX.out file to plot maximum wind	!
!	(Wmax) and maximum wind radius (Rmax)                  	!
!---------------------------------------------------------------!
	parameter (ItMax=230500,LU0=5,LU1=3)
	real*4 T(0:ItMax),X(0:ItMax),Y(0:ItMax),CX(0:ItMax),
     1         CY(0:ItMax),Dx(0:ItMax),Dy(0:ItMax),
     2         T1(0:ItMax),X1(0:ItMax),Y1(0:ItMax),CX1(0:ItMax),
     3         CY1(0:ItMax),Dx1(0:ItMax),Dy1(0:ItMax)
	character IDString*20,FDate*9,FTime*8,TITLE*25,TITLE2*25,
     1            TITLE1*20,FDate1*9,FTime1*8,IDif*9
	logical IPort,ITrak1

c Read set-up from file trakXXX.set
        call GetParms(ItFirst,ItBegin,ItLast,ItFirst1,ItBegin1,ItLast1,
     1          NSym,XMin,XInt,XMax,YMin,YInt,YMax,
     2          XRat,CInt,CMax,TInt,TRat,TITLE,TITLE2,IPort,ITrak1,
     3          XMin1,XInt1,XMax1,YMin1,YInt1,YMax1,    
     4          XRat1,CInt1,CMax1,TInt1,TRat1,Pics,Pic2)
        NPos = ItLast - ItFirst
        ItStart = ItBegin - ItFirst
        ItEnd = NPos
        NPos1 = ItLast1 - ItFirst1
        ItStart1 = ItBegin1 - ItFirst1
        ItEnd1 = NPos1

c Read primary track data
 	call ReadTrak(NPos,T,X,Y,CX,CY,Dx,Dy,T1,X1,Y1,CX1,CY1,DX1,Dy1,
     1               IDString,FDate,FTime,IDif,LU0)

c Show file identification and data every hour
	write(6,'(1x,A20,1x,A8,1x,A9)')
     1                    IDString,FTime,FDate

	do It = ItStart, ItEnd,288
	  write(6,22)It,T(It),X(It),Y(It),CX(It),CY(It)
	enddo

	do It = ItStart, ItEnd,288
	  write(6,22)It,T1(It),X1(It),Y1(It),CX1(It),CY1(It)
	enddo

c Reading a second track? No

        call TrakPlot(T,X,Y,CX,CY,Dx,Dy,TITLE,TITLE2,
     1               T1,X1,Y1,CX1,CY1,Dx1,Dy1,TITLE1,
     2               IDString,FDate,FTime,IDif,
     3               XMin,XInt,XMax,YMin,YInt,YMax,
     4               XRat,CInt,CMax,TInt,TRat,
     3               XMin1,XInt1,XMax1,YMin1,YInt1,YMax1,
     4               XRat1,CInt1,CMax1,TInt1,TRat1,
     5               ItStart,ItEnd,ItStart1,ItEnd1,
     6               NSym,IPort,ITrak1,Pics,Pic2)

 22	format(1x,i6,5(1x,g10.3))

	stop
	end

	subroutine ReadTrak(NPos,T,X,Y,CX,CY,DX,DY,T1,X1,Y1,CX1,CY1,
     1                      DX1,DY1,IDString,FDate,FTime,IDif,LU)
	parameter (ItMax=230500)
        integer*4 NN(0:ItMax)
	real*4 T(0:ItMax),X(0:ItMax),Y(0:ItMax),CX(0:ItMax),
     1         CY(0:ItMax),DX(0:ItMax),DY(0:ItMax)
	real*4 T1(0:ItMax),X1(0:ItMax),Y1(0:ItMax),CX1(0:ItMax),
     1         CY1(0:ItMax),DX1(0:ItMax),DY1(0:ItMax)
	character IDString*20,FDate*9,FTime*8,
     1            Stringer*60,IDif*9
        common/Deltat/ Dth

c End of loop less than array dimension
	NPos= MIN(NPos,ItMax)

c FInd marker for start of data
	read(LU,'(a60)',end=98)Stringer
	IdxStr = index(Stringer,'##########')
	do while(IdxStr .eq. 0)
	   read(LU,'(a60)',end=98)Stringer
	   IdxStr = index(Stringer,'##########')
	enddo

c Read date/time stamps and run ID
	read(LU,'(1x,A20,1x,A8,1x,A9,1x,A7)')IDString,FTime,
     1                                       FDate,IDif

c Read data
	do It = 0, NPos
          NLast = It
	  read(LU,*,end=98)NN(It),T(It),I,X(It),Y(It),CX(It),CY(It)
	  read(LU,*,end=98)N,T1(It),J,X1(It),Y1(It),CX1(It),CY1(It)
c         if(It.eq.0) then
c           write(6,22)t(It),x(It),y(It)
c           write(6,22)t1(It),x1(It),y1(It)
c   22     format(1x,f8.3,2(1x,f8.2))
c         endif
	enddo

        do It = 1,NLast
           if(T(It) .eq. T(0) + .1) RNSave = NN(It)
        enddo

c NN(1) is needed to account for packed data where output times are skipped
        Dth = NN(1)*360./RNSave


 98	NPos= MIN(NPos,NLast)
	return 
	end
     
      subroutine TrakPlot(T,X,Y,RM,WM,Dx,Dy,TITLE,TITLE2,
     1              T1,X1,Y1,RM1,WM1,Dx1,Dy1,TITLE1,
     2              IDString,FDate,FTime,IDif,
     3              XMin,XInt,XMax,YMin,YInt,YMax,
     4              XRat,CInt,CMax,TInt,TRat,
     3              XMin1,XInt1,XMax1,YMin1,YInt1,YMax1,
     4              XRat1,CInt1,CMax1,TInt1,TRat1,
     5              ItStart,ItEnd,ItStart1,ItEnd1,
     6              NSym,IPort,ITrak1,Pics,Pic2)
      parameter (ItMax=230500)
      real*4 T(0:ItMax),X(0:ItMax),Y(0:ItMax),RM(0:ItMax),
     1       WM(0:ItMax),ARay(0:ItMax),TRay(0:ItMax),T1(0:ItMax),
     2       X1(0:ItMax),Y1(0:ItMax),RM1(0:ItMax),WM1(0:ItMax),
     3       Dx(0:ItMax),Dy(0:ItMax),Dx1(0:ItMax),Dy1(0:ItMax),
     4       XDum(0:ItMax),YDum(0:ItMax),XM(0:ItMax),YM(0:ItMax),
     5       CXM(0:ItMax),CYM(0:ItMax),Cxt(0:ItMax),Cyt(0:ItMax)
      character IDString*20,FDate*9,FTime*8,TITLE*25,
     1          TITLE2*25,CBuffer*40,TITLE1*25,IDif*9,NJAX*9,TIT*9
      common/Deltat/ Dth
      PARAMETER(HafCSz=2.0,VSmCSz=1.5*HafCSz,SmCSz=2.*HafCSz)
      PARAMETER (BgCSz=3.0*HafCSz)
      PARAMETER(XLong=20.,XShort=35.,wsolid=0.5,wdot=1.0)
      logical IPort,ITrak1,IBreak

      NJAX = IDif
      IDString = TITLE2
c Activate graphics

      Ipics = 1

      call groute('select hposta;ex')  

      call RORIEN(1)

      call gopen

      call gsegwk(0)

      call gprint(0)
 
c Open Rmax and Wmax plot segment
      CALL GSEGCR( 1 )
      XXMax = 265.0
      YYMax =  205.0

C Assign locations for components of graf

      YBot=  XShort
      YHi = YYMax - 2*YBot
      if(Ipics .eq. 1 .or. Ipics .eq. 2) then
       XWide = TRat*YHi
      else
       XWide = TRat1*YHi
      endif
      XLft = 0.5*(XXMax-XWide)
      XRt =  XLft + XWide 
      YTop = YBot + YHi
      YLR = YTop + HafCSz
      XCtr = XXMax/2.
      YHed = YLR + 1.5*BgCSz

c Select character font
       call rtxesc(-5,' ')
       call rtxfon('COMP', 1)
c      call gcharf('SOFT')
c      call gcharf('TRIP')

C Plot headers on graph

      CALL GCHARJ( 1 )
      CALL GCHAR( TITLE, XCtr, YHed, BgCSz)
      CALL GCHARJ( 0 )

      CALL GCHARJ( 0 )
      CALL GCHAR( 'Time: $' , XLft, YLR, SmCSz )
      call gnumb(T(ItStart),9999.,9999.,SmCSz,0)
      call gchar(' to $',9999.,9999.,SmCSz)     
      call gnumb(T(ItEnd),9999.,9999.,SmCSz,0)
      call gchar(' h$',9999.,9999.,SmCSz)     

      CALL GCHARJ( 2 )
      CBuffer = NJAX//'$'
      CALL GCHAR( CBuffer, XRt, YLR, SmCSz )

C Set where you want graph to be on plot
      CALL BGRAF( XLft, YBot, XWide, YHi)

C Set up t-Axis
      CALL BAXLAB( SmCSz, SmCSz, 0, 0 )
      Tstart = ANINT(T(ItStart))
      Tend = ANINT(T(ItEnd))
      if(Ipics .eq. 1 .or. Ipics .eq. 2) then
       CALL BAXIS( 1, Tstart, TInt, Tend, 't (hr) $' )
      else
       CALL BAXIS( 1, Tstart, TInt1, Tend, 't (hr) $' )
      endif

C Set up Maximum Wind Axis
      CALL BAXLAB( SmCSz, SmCSz, 0, 0 )
      CALL BAXIS( 2, 0.0, CInt, CMax , 'Wmax (ms>->1)$' )

C Set up line characteristics
      CALL BLIWDH( wsolid )
      CALL BDASH( 0 )

C Plot L1 Wmax vs. t


c Move speed to dummy arrays
      call MovRays(T,Wm,XDum,YDum,ItStart,ItENd, Kount )

c Plot Wmax L1
      CALL BLINE(XDum,YDum,Kount)

c PLOT Wmax L2

      CALL BLIWDH( wsolid )
      CALL BDASH( 3 )
      CALL BLINE( T, Wm1, Kount)

C Set up Maximum Wind Radius-Axis

      call baxori(XRt,YBot)
      CALL BAXLAB( SmCSz, SmCSz, 0, 0 )
      CALL BAXIS( -2, 0.0, CInt1, CMax1 , ' Rmax (km)$' )


C Plot L1 Maximum Wind Radius vs. T 

          CALL BLIWDH( wdot )
          CALL BDASH( 1 )
          CALL BLINE( T, Rm, Kount )


C Plot L2 Radius of Maximum Wind

      CALL BDASH( 5 )
      CALL BLINE( T, Rm1, Kount)

      CBuffer = IDString//'$'
      call GCHARJ(0)
      call GCHAR(CBuffer,XLft,HafCsz,VSmCSz)
      CBuffer = FTime//' '//FDate//'$'
      call GCHARJ(2)
      call GCHAR(CBuffer,XRt,HafCSz,VSmCSz)

      IDif = 'Lev1&Lev2'

      CBuffer = IDif//'$'
      CALL GCHARJ(1)
      CALL GCHAR( CBuffer, XCtr, HafCSz, VSmCSz)
      CALL GSEGCL( 1 )
      CALL GCLOSE

  99  continue


      RETURN
      END


        subroutine GetParms(ItFirst,ItBegin,ItLast,ItFirst1,ItBegin1,
     1          ItLast1,NSym,XMin,XInt,XMax,YMin,YInt,YMax,
     2          XRat,CInt,CMax,TInt,TRat,TITLE,TITLE2,IPort,ITrak1,
     3          XMin1,XInt1,XMax1,YMin1,YInt1,YMax1,
     4          XRat1,CInt1,CMax1,TInt1,TRat1,Pics,Pic2)
	character TITLE*25,TITLE2*25
	logical IPort,ITrak1
	read(4,*)IPort,ITrak1
	read(4,'(A25)')TITLE
	read(4,'(A25)')TITLE2
	read(4,*)ItFirst,ItBegin,ItLast,NSym
        read(4,*)ItFirst1,ItBegin1,ItLast1
	read(4,*)XMin,XInt,XMax
	read(4,*)YMin,YInt,YMax,XRat
	read(4,*)CInt,CMax
	read(4,*)TInt,TRat
	read(4,*)XMin1,XInt1,XMax1
	read(4,*)YMin1,YInt1,YMax1,XRat1
	read(4,*)CInt1,CMax1
	read(4,*)TInt1,TRat1,Pics,Pic2
	return
	end

        subroutine MovRays(X,Y,XDum,YDum,ItFirst,ItLast,Kount)
        parameter (ItMax=230500)
        real*4 X(0:ItMax),Y(0:ItMax),XDum(0:ItMax),YDum(0:ItMax)
        Kount=0
        do It = ItFirst,ItLast
          XDum(Kount)=X(It)
          YDum(Kount)=Y(It)
          Kount=Kount+1
        enddo
        return
        end

        subroutine ReadSet(FDate,FTime,Rho)
        real*4 Rho(3)
	character FDate*9,FTime*8,Dummy*72

        read(9,'(a72)')Dummy
        read(9,'(1x,a9,1x,a8,1x,a9)')Dummy,FTime,FDate
        do i=1,15
           read(9,'(a72)')Dummy
        enddo
        read(9,'(1x,a28,1x,3g13.6)')Dummy,Rho
        write(6,*)Rho
        return
        end


