
	program RmWmNGraf
!---------------------------------------------------------------!
!	Program name: RMWMGRAF 					!
!	Written by: H.E. WIlloughby AOML/HRD			!
!	Latest update:	4FEB15	by:	RWJ			!
!	Function: Uses trakXXX.out file to plot maximum wind	!
!	(Wmax) and maximum wind radius (Rmax) for NTraks        !
!---------------------------------------------------------------!
	parameter (ItMax=144000)
	real*4 T(8,0:ItMax),X(0:ItMax),Y(0:ItMax),CX(8,0:ItMax),
     1         CY(8,0:ItMax),
     2         T1(8,0:ItMax),X1(0:ItMax),Y1(0:ItMax),CX1(8,0:ItMax),
     3         CY1(8,0:ItMax),ALine(8)
        integer*4 ItStart(8),ItEnd(8),LURay(8),KLine(8)
	character IDString*20,FDate*9,FTime*8,TITLE*40,TITLE2*25,
     1            TITLE1*30,FDate1*9,FTime1*8,IDif*6,IDif1*6,
     2            IDString1*20
	logical IPort
        data LURay/5,3,7,8,9,10,11,12/
        data KLine/0,1,5,10,3,7,8,9/
        data ALine/0.5,1.0,0.5,0.5,1.0,0.5,0.5,0.5/

c Read set-up from file trakXXX.set
        call GetParms(ItStart,ItEnd,
     2          CInt,CMax,TInt,TRat,TITLE,TITLE1,TITLE2,IPort,NTraks,
     4          CInt1,CMax1,TInt1,TRat1)

c Read primary track data
       do k = 1, NTraks 
        NPos = ItEnd(k)
        LU = LURay(k)
 	call ReadTrak(NPos,T,X,Y,CX,CY,T1,X1,Y1,CX1,CY1,k,
     1                     IDString,FDate,FTime,IDif,LU)

        if(k .eq. 1)then
          IDString1 = IDString
          FDate1 = FDate
          FTime1 = FTime
          IDif1 = IDif
        endif

c Show file identification and data every hour
	write(6,'(1x,A20,1x,A8,1x,A9)')
     1                    IDString,FTime,FDate

	do It = ItStart(k), ItEnd(k),288
	  write(6,22)It,T(k,It),X(It),Y(It),CX(k,It),CY(k,It)
	enddo

	do It = ItStart(k), ItEnd(k),288
	  write(6,22)It,T1(k,It),X1(It),Y1(It),CX1(k,It),CY1(k,It)
	enddo
       enddo

        call TrakPlot(T,X,Y,CX,CY,TITLE,TITLE2,
     1               T1,X1,Y1,CX1,CY1,TITLE1,
     2               IDString,FDate,FTime,FDate1,FTime1,IDif,IDif1,
     3               CInt,CMax,TInt,TRat,
     4               CInt1,CMax1,TInt1,TRat1,
     6               ItStart,ItEnd,ALine,KLine
     7               IPort,NTraks)

 22	format(1x,i6,5(1x,g10.3))

	stop
	end

	subroutine ReadTrak(NPos,T,X,Y,CX,CY,T1,X1,Y1,CX1,CY1,k,
     1                      IDString,FDate,FTime,IDif,LU)
	parameter (ItMax=144000)
        integer*4 NN(0:ItMax)
	real*4 T(8,0:ItMax),X(0:ItMax),Y(0:ItMax),CX(8,0:ItMax),
     1         CY(8,0:ItMax)
	real*4 T1(8,0:ItMax),X1(0:ItMax),Y1(0:ItMax),CX1(8,0:ItMax),
     1         CY1(8,0:ItMax)
	character IDString*20,FDate*9,FTime*8,
     1            Stringer*60,IDif*6

c End of loop less than array dimension
	NPos= MIN(NPos,ItMax)

c FInd marker for start of data
	read(LU,'(a60)',end=98)Stringer
	IdxStr = index(Stringer,'##########')
	do while(IdxStr .eq. 0)
	   read(LU,'(a60)',end=98)Stringer
	   IdxStr = index(Stringer,'##########')
	enddo

c Read date/time stamps and run ID
	read(LU,'(1x,A20,1x,A8,1x,A9,1x,A7)')IDString,FTime,
     1                                       FDate,IDif

c Read data
	do It = 0, NPos
          NLast = It
	  read(LU,*,end=98)NN(It),T(k,It),I,X(It),Y(It),
     1                       CX(k,It),CY(k,It)
	  read(LU,*,end=98)N,T1(k,It),J,X1(It),Y1(It),
     1                       CX1(k,It),CY1(k,It)
c         if(It.eq.0) then
c           write(6,22)t(It),x(It),y(It)
c           write(6,22)t1(It),x1(It),y1(It)
c   22     format(1x,f8.3,2(1x,f8.2))
c         endif
	enddo


 98	NPos= MIN(NPos,NLast)
	return 
	end
     
      subroutine TrakPlot(T,X,Y,RM,WM,TITLE,TITLE2,
     1              T1,X1,Y1,RM1,WM1,TITLE1,
     2              IDString,FDate,FTime,FDate1,FTime1,IDif,IDif1,
     4              CInt,CMax,TInt,TRat,
     4              CInt1,CMax1,TInt1,TRat1,
     5              ItStart,ItEnd,ALine,Kline
     6              IPort,NTraks)
      parameter (ItMax=144000)
      real*4 T(8,0:ItMax),X(0:ItMax),Y(0:ItMax),RM(8,0:ItMax),
     1       WM(8,0:ItMax),ARay(0:ItMax),TRay(0:ItMax),T1(8,0:ItMax),
     2       X1(0:ItMax),Y1(0:ItMax),RM1(8,0:ItMax),WM1(8,0:ItMax),
     3       XDum(0:ItMax),YDum(0:ItMax),ALine(8)
      integer*4 KLine(8),ItStart(8),ItEnd(8)
      character IDString*20,FDate*9,FTime*8,FDate1*9,FTime1*8,TITLE*40,
     1          TITLE2*25,CBuffer*40,TITLE1*30,IDif*6,IDif1*6,TIT*9
      PARAMETER(HafCSz=2.0,VSmCSz=1.5*HafCSz,SmCSz=2.*HafCSz)
      PARAMETER (BgCSz=3.0*HafCSz)
      PARAMETER(XLong=20.,XShort=35.,wsolid=0.5,wdot=1.0)
      logical IPort

      IDString = TITLE2
c Activate graphics

      Ipics = 1

      call groute('select hposta;ex')  

      call RORIEN(1)

      call gopen

      call gsegwk(0)

      call gprint(0)
 
c Open Rmax and Wmax plot segment
      CALL GSEGCR( 1 )
      XXMax = 265.0
      YYMax =  205.0

C Assign locations for components of graf

      YBot=  XShort
      YHi = YYMax - 2*YBot
      if(Ipics .eq. 1 .or. Ipics .eq. 2) then
       XWide = TRat*YHi
      else
       XWide = TRat1*YHi
      endif
      XLft = 0.5*(XXMax-XWide)
      XRt =  XLft + XWide 
      YTop = YBot + YHi
      YLR = YTop + HafCSz
      XCtr = XXMax/2.
      YHed = YLR + 1.5*BgCSz

c Select character font
       call rtxesc(-5,' ')
       call rtxfon('COMP', 1)
c      call gcharf('SOFT')
c      call gcharf('TRIP')

C Plot headers on graph

      CALL GCHARJ( 1 )
      CALL GCHAR( TITLE, XCtr, YHed, BgCSz)
      CALL GCHARJ( 0 )

      CALL GCHARJ( 0 )
      CBuffer = TITLE1//'$'
      CALL GCHAR( CBuffer, XLft, YLR, SmCSz )
c      CALL GCHAR( 'Time: $' , XLft, YLR, SmCSz )
c      Time = T(1,ItStart(1))
c      call gnumb(Time,9999.,9999.,SmCSz,0)
c      call gchar(' to $',9999.,9999.,SmCSz)     
c      Time = T(1,ItEnd(1))
c      call gnumb(Time,9999.,9999.,SmCSz,0)
c      call gchar(' h$',9999.,9999.,SmCSz)     

      CALL GCHARJ( 2 )
      CBuffer = IDif1//' '//IDif//'$'
      CALL GCHAR( CBuffer, XRt, YLR, SmCSz )

C Set where you want graph to be on plot
      CALL BGRAF( XLft, YBot, XWide, YHi)

C Set up t-Axis
      CALL BAXLAB( SmCSz, SmCSz, 0, 0 )
      Tstart = ANINT(T(1,ItStart(1)))
      Tend = ANINT(T(1,ItEnd(1)))
      if(Ipics .eq. 1 .or. Ipics .eq. 2) then
       CALL BAXIS( 1, Tstart, TInt, Tend, 't (hr) $' )
      else
       CALL BAXIS( 1, Tstart, TInt, Tend, 't (hr) $' )
      endif

C Set up Maximum Wind Axis
      CALL BAXLAB( SmCSz, SmCSz, 0, 0 )
      CALL BAXIS( 2, 0.0, CInt, CMax , 'Wmax (ms>->1)$' )

C Set up line characteristics
c      CALL BLIWDH( wsolid )
c      CALL BDASH( 0 )

C Plot L1 Wmax vs. t


c Move speed to dummy arrays
      do k = 1,NTraks

        CALL BLIWDH( wsolid )
        CALL BDASH( 0 )

        call MovRays(T,Wm,XDum,YDum,k,ItStart,ItEnd, Kount )

c Plot Wmax L1
        CALL BLINE(XDum,YDum,Kount)


c PLOT Wmax L2

        call MovRays(T,Wm1,XDum,YDum,k,ItStart,ItEnd, Kount)

        CALL BLIWDH( wsolid )
        CALL BDASH( 3 )
        CALL BLINE(XDum,YDum, Kount)
      enddo

C Set up Maximum Wind Radius-Axis

      call baxori(XRt,YBot)
      CALL BAXLAB( SmCSz, SmCSz, 0, 0 )
      CALL BAXIS( -2, 0.0, CInt1, CMax1 , ' Rmax (km)$' )


C Plot L1 Maximum Wind Radius vs. T 

        do k = 1, NTraks
          CALL BLIWDH( wdot )
          CALL BDASH( 1 )
          call MovRays(T,Rm,XDum,YDum,k,ItStart,ItEnd, Kount)

          CALL BLINE( XDum, YDum, Kount )


C Plot L2 Radius of Maximum Wind

          CALL BDASH( 5 )
          call MovRays(T,Rm1,XDum,YDum,k,ItStart,ItEnd, Kount)

          CALL BLINE(XDum, YDum, Kount)    
        enddo

      CBuffer = FTime1//' '//FDate1//'$'
      call GCHARJ(0)
      call GCHAR(CBuffer,XLft,HafCsz,VSmCSz)
      CBuffer = FTime//' '//FDate//'$'
      call GCHARJ(2)
      call GCHAR(CBuffer,XRt,HafCSz,VSmCSz)


      CBuffer = IDString//'$'
      CALL GCHARJ(1)
      CALL GCHAR( CBuffer, XCtr, HafCSz, VSmCSz)
      CALL GSEGCL( 1 )
      CALL GCLOSE

  99  continue


      RETURN
      END


        subroutine GetParms(ItStart,ItEnd,
     1          CInt,CMax,TInt,TRat,TITLE,TITLE1,TITLE2,IPort,NTraks,
     2          CInt1,CMax1,TInt1,TRat1)
        integer*4 ItStart(8),ItEnd(8)
	character TITLE*40,TITLE1*30,TITLE2*25
	logical IPort
	read(4,*)IPort,NTraks
	read(4,'(A40)')TITLE
        read(4,'(A30)')TITLE1
	read(4,'(A25)')TITLE2
	read(4,*)CInt,CMax
	read(4,*)TInt,TRat
	read(4,*)CInt1,CMax1
	read(4,*)TInt1,TRat1
        do k = 1, NTraks
         read(4,*)ItStart(k),ItEnd(k)
        enddo
	return
	end

        subroutine MovRays(X,Y,XDum,YDum,k,ItStart,ItEnd,Kount)
        parameter (ItMax=144000)
        real*4 X(8,0:ItMax),Y(8,0:ItMax),XDum(0:ItMax),YDum(0:ItMax)
        integer*4 ItStart(8),ItEnd(8)   
        Kount=0
        ItFirst = ItStart(k)
        ItLast = ItEnd(k)
        do It = ItFirst,ItLast
          XDum(Kount)=X(k,It)
          YDum(Kount)=Y(k,It)
          Kount=Kount+1
        enddo
        return
        end

        subroutine ReadSet(FDate,FTime,Rho)
        real*4 Rho(3)
	character FDate*9,FTime*8,Dummy*72

        read(9,'(a72)')Dummy
        read(9,'(1x,a9,1x,a8,1x,a9)')Dummy,FTime,FDate
        do i=1,15
           read(9,'(a72)')Dummy
        enddo
        read(9,'(1x,a28,1x,3g13.6)')Dummy,Rho
        write(6,*)Rho
        return
        end


