
	program TrakGraf
!---------------------------------------------------------------!
!	Program name: TRAKGRAF 					!
!	Written by: H.E. WIlloughby AOML/HRD			!
!	Latest update:	07SEP01	by:	RWJ			!
!	Function: Uses trakXXX.out file to plot storm track	!
!	plus an optional second reference track. Makes a second	!
!	plot of the primary track's direction and speed		!
!---------------------------------------------------------------!
	parameter (ItMax=230500,LU0=5,LU1=3)
	real*4 T(0:ItMax),X(0:ItMax),Y(0:ItMax),CX(0:ItMax),
     1         CY(0:ItMax),Dx(0:ItMax),Dy(0:ItMax),
     2         T1(0:ItMax),X1(0:ItMax),Y1(0:ItMax),CX1(0:ItMax),
     3         CY1(0:ItMax),Dx1(0:ItMax),Dy1(0:ItMax)
	character IDString*20,FDate*9,FTime*8,TITLE*25,TITLE2*25,
     1            TITLE1*20,FDate1*9,FTime1*8,IDif*9
	logical IPort,ITrak1

c Read set-up from file trakXXX.set
        call GetParms(ItFirst,ItBegin,ItLast,ItFirst1,ItBegin1,ItLast1,
     1          NSym,XMin,XInt,XMax,YMin,YInt,YMax,
     2          XRat,CInt,CMax,TInt,TRat,TITLE,TITLE2,IPort,ITrak1,
     3          XMin1,XInt1,XMax1,YMin1,YInt1,YMax1,    
     4          XRat1,CInt1,CMax1,TInt1,TRat1,Pics,Pic2)
        NPos = ItLast - ItFirst
        ItStart = ItBegin - ItFirst
        ItEnd = NPos
        NPos1 = ItLast1 - ItFirst1
        ItStart1 = ItBegin1 - ItFirst1
        ItEnd1 = NPos1

c Read primary track data
 	call ReadTrak(NPos,T,X,Y,CX,CY,Dx,Dy,T1,X1,Y1,CX1,CY1,DX1,Dy1,
     1               IDString,FDate,FTime,IDif,LU0)

c Show file identification and data every hour
	write(6,'(1x,A20,1x,A8,1x,A9)')
     1                    IDString,FTime,FDate

	do It = ItStart, ItEnd,288
	  write(6,22)It,T(It),X(It),Y(It),CX(It),CY(It)
	enddo

	do It = ItStart, ItEnd,288
	  write(6,22)It,T1(It),X1(It),Y1(It),CX1(It),CY1(It)
	enddo

c Reading a second track? No

        call TrakPlot(T,X,Y,CX,CY,Dx,Dy,TITLE,TITLE2,
     1               T1,X1,Y1,CX1,CY1,Dx1,Dy1,TITLE1,
     2               IDString,FDate,FTime,IDif,
     3               XMin,XInt,XMax,YMin,YInt,YMax,
     4               XRat,CInt,CMax,TInt,TRat,
     3               XMin1,XInt1,XMax1,YMin1,YInt1,YMax1,
     4               XRat1,CInt1,CMax1,TInt1,TRat1,
     5               ItStart,ItEnd,ItStart1,ItEnd1,
     6               NSym,IPort,ITrak1,Pics,Pic2)

 22	format(1x,i6,5(1x,g10.3))

	stop
	end

	subroutine ReadTrak(NPos,T,X,Y,CX,CY,DX,DY,T1,X1,Y1,CX1,CY1,
     1                      DX1,DY1,IDString,FDate,FTime,IDif,LU)
	parameter (ItMax=230500)
        integer*4 NN(0:ItMax)
	real*4 T(0:ItMax),X(0:ItMax),Y(0:ItMax),CX(0:ItMax),
     1         CY(0:ItMax),DX(0:ItMax),DY(0:ItMax)
	real*4 T1(0:ItMax),X1(0:ItMax),Y1(0:ItMax),CX1(0:ItMax),
     1         CY1(0:ItMax),DX1(0:ItMax),DY1(0:ItMax)
	character IDString*20,FDate*9,FTime*8,
     1            Stringer*60,IDif*9
        common/Deltat/ Dth

c End of loop less than array dimension
	NPos= MIN(NPos,ItMax)

c FInd marker for start of data
	read(LU,'(a60)',end=98)Stringer
	IdxStr = index(Stringer,'##########')
	do while(IdxStr .eq. 0)
	   read(LU,'(a60)',end=98)Stringer
	   IdxStr = index(Stringer,'##########')
	enddo

c Read date/time stamps and run ID
	read(LU,'(1x,A20,1x,A8,1x,A9,1x,A7)')IDString,FTime,
     1                                       FDate,IDif

c Read data
	do It = 0, NPos
          NLast = It
	  read(LU,*,end=98)NN(It),T(It),I,X(It),Y(It),CX(It),CY(It)
c     1                        DX(It),DY(It)
	  read(LU,*,end=98)N,T1(It),J,X1(It),Y1(It),CX1(It),CY1(It)
c     1                        DX1(It),DY1(It)
c         if(It.eq.0) then
c           write(6,22)t(It),x(It),y(It)
c           write(6,22)t1(It),x1(It),y1(It)
c   22     format(1x,f8.3,2(1x,f8.2))
c         endif
	enddo

        do It = 1,NLast
           if(T(It) .eq. T(0) + .1) RNSave = NN(It)
        enddo

c NN(1) is needed to account for packed data where output times are skipped
        Dth = NN(1)*360./RNSave

        do It = 1,NLast - 1
           CX(It) = (X(It+1) - X(It-1))*500./Dth
           CY(It) = (Y(It+1) - Y(It-1))*500./Dth
           CX1(It) = (X1(It+1) - X1(It-1))*500./Dth
           CY1(It) = (Y1(It+1) - Y1(It-1))*500./Dth
        enddo

 98	NPos= MIN(NPos,NLast)
	return 
	end
     
      subroutine TrakPlot(T,X,Y,CX,CY,Dx,Dy,TITLE,TITLE2,
     1              T1,X1,Y1,CX1,CY1,Dx1,Dy1,TITLE1,
     2              IDString,FDate,FTime,IDif,
     3              XMin,XInt,XMax,YMin,YInt,YMax,
     4              XRat,CInt,CMax,TInt,TRat,
     3              XMin1,XInt1,XMax1,YMin1,YInt1,YMax1,
     4              XRat1,CInt1,CMax1,TInt1,TRat1,
     5              ItStart,ItEnd,ItStart1,ItEnd1,
     6              NSym,IPort,ITrak1,Pics,Pic2)
      parameter (ItMax=230500)
      real*4 T(0:ItMax),X(0:ItMax),Y(0:ItMax),CX(0:ItMax),
     1       CY(0:ItMax),ARay(0:ItMax),TRay(0:ItMax),T1(0:ItMax),
     2       X1(0:ItMax),Y1(0:ItMax),CX1(0:ItMax),CY1(0:ItMax),
     3       Dx(0:ItMax),Dy(0:ItMax),Dx1(0:ItMax),Dy1(0:ItMax),
     4       XDum(0:ItMax),YDum(0:ItMax),XM(0:ItMax),YM(0:ItMax),
     5       CXM(0:ItMax),CYM(0:ItMax),Cxt(0:ItMax),Cyt(0:ItMax)
      character IDString*20,FDate*9,FTime*8,TITLE*25,
     1          TITLE2*25,CBuffer*40,TITLE1*25,IDif*9,NJAX*9,TIT*9
      common/Deltat/ Dth
      PARAMETER(HafCSz=2.0,VSmCSz=1.5*HafCSz,SmCSz=2.*HafCSz)
      PARAMETER (BgCSz=3.0*HafCSz)
      PARAMETER(XLong=20.,XShort=35.,wsolid=0.5,wdot=1.0)
      logical IPort,ITrak1,IBreak

      NJAX = IDif
      TIT = TITLE2
c Activeate graphics
      do Ipics = 1,Pics
      call groute('select hposta;ex')
      CALL GOPEN
      if(IPort)then 
         call RORIEN(2)
      else
         call RORIEN(1)
      endif
      CALL GPRINT( 0 )

      CALL GSEGCR( 1 )
      call grpsiz(XXMax,YYMax)

C Assign locations for components of graf
      YTop = YYMax - 9.0*HafCSz
      YLR = YTop + HafCSz
      XCtr = XXMax/2. 
      if(IPort)then
        XLft=XShort
        XRt =  XXMax - 4.0*HafCSz
        XWide = XRt - XLft
       if(Ipics .eq.1 .or. Ipics .eq. 2) then
        YHi = XWide*(YMax-YMin)/(XRat*(XMax-XMin))
       else
        YHi = XWide*(YMax1-YMin1)/(XRat1*(XMax1-XMin1))
       endif
        YBot = YTop - YHi
      else
        YBot = XShort
        YHi = YTop - YBot
       if(Ipics .eq. 1 .or. Ipics .eq. 2) then
        XWide = YHi*XRat*(XMax-XMin)/(YMax-YMin)
       else
        XWide = YHi*XRat1*(XMax1-XMin1)/(YMax1-YMin1)
       endif
        XLft = 0.5*(XXMax-XWide)
        XRt = XXMax - XLft
      endif 

c Select character font
      call rtxesc(-5,' ')
      call rtxfon('COMP',1)

C Plot headers on graph
      CALL GCHARJ( 7 )
      CALL GCHAR( TITLE, XCtr, YYMax-HafCSz, BgCSz)

      CALL GCHARJ( 0 )
      CALL GCHAR( 'Time: $' , XLft, YLR, SmCSz )
      call gnumb(T(ItStart),9999.,9999.,SmCSz,0)
      call gchar(' to $',9999.,9999.,SmCSz)     
      call gnumb(T(ItEnd),9999.,9999.,SmCSz,0)
      call gchar(' h$',9999.,9999.,SmCSz)     

      CALL GCHARJ( 2 )
      CBuffer = NJAX//'$'
      CALL GCHAR( CBuffer, XRt, YLR, SmCSz )

C Turn on full display of error messages
      CALL GSHMES( 'DIS', 'DIS' )

C Set where you want graph to be on plot
      CALL BGRAF( XLft, YBot, XWide, YHi)

C Set up X-Axis
c     call bloglb(1.0,2,1)
      CALL BAXLAB( SmCSz, SmCSz, 0, 0 )
      if(Ipics .eq. 1 .or. Ipics .eq. 2) then
       CALL BAXIS( 1, XMin, XInt, XMax, 'X  (km)$' )
      else
       CALL BAXIS( 1, XMin1, XInt1, XMax1, 'X  (km)$' )
      endif

C Set up Y-Axis

c     call bloglb(1.0,2,1)
      CALL BAXLAB( SmCSz, SmCSz, 0, 0 )
      if(Ipics .eq. 1 .or. Ipics .eq. 2) then 
       CALL BAXIS( 2, YMin, YInt, YMax , 'Y (km)$' )    
      else
       CALL BAXIS( 2, YMin1, YInt1, YMax1 , 'Y (km)$' )    
      endif
 
C Set up line characteristics

      CALL BLIWDH( wsolid )
      call gcharj(4)
      call bmarkh(SmCSz)
      call bmark(-768,NSym)

c Move primary track into dummy arrays
      call MovRays(X,Y,XDum,YDum,ItStart,ItEnd,Kount)

c If Ipics = 2 make plot of mean track
      if(Ipics . eq. 2) then
        do i=0,ItMax
          XM(i) = (X1(i) + X(i))/2.
          YM(i) = (Y1(i) + Y(i))/2.
          CXM(i) = (CX1(i) + CX(i))/2.
          CYM(i) = (CY1(i) + CY(i))/2.
        enddo

c Move primary track into dummy arrays
        call MovRays(XM,YM,XDum,YDum,ItStart,ItEnd,Kount)
      endif

c If Ipics = 3 make plot of level two wrt level one
      if(Ipics . eq. 3) then
        do i=0,ItMax
          X(i) = x1(i) - x(i)
          Y(i) = y1(i) - y(i)
          X(i) = Dx1(i) - Dx(i)
          Y(i) = Dy1(i) - Dy(i)
          CX(i) = (X(i) - X(i-1))*1000./Dth
          CY(i) = (Y(i) - Y(i-1))*1000./Dth
        enddo

c Move primary track into dummy arrays
        call MovRays(X,Y,XDum,YDum,ItStart,ItEnd,Kount)
      endif

c If Ipics = 4 make plot of level one wrt the mean track
      if(Ipics . eq. 4) then
        do i=0,ItMax
          X1(i) = -X(i)/2.
          Y1(i) = -Y(i)/2.
          CX1(i) = (X1(i) - X1(i-1))*1000./Dth
          CY1(i) = (Y1(i) - Y1(i-1))*1000./Dth
        enddo

c Move primary track into dummy arrays
        call MovRays(X1,Y1,XDum,YDum,ItStart,ItEnd,Kount)
      endif

c If Ipics = 5 make plot of level two wrt the mean track
      if(Ipics . eq. 5) then
        do i=0,ItMax
          X(i) = X(i)/2.
          Y(i) = Y(i)/2.
          CX(i) = (X(i) - X(i-1))*1000./Dth
          CY(i) = (Y(i) - Y(i-1))*1000./Dth
        enddo

c Move primary track into dummy arrays
        call MovRays(X,Y,XDum,YDum,ItStart,ItEnd,Kount)
      endif


C Plot Track

      CALL BDASH( 0 )
      CALL BLINE( XDum, YDum, Kount )


C PLoting comparison track when Ipics is 1?
      if(ITrak1 .and. Ipics .eq. 1)then

c Move comparison track into dummy arrays
        call MovRays(X1,Y1,XDum,YDum,ItStart1,ItEnd1,Kount)

c Set symbol and line characteristics
        call bmark(-850,NSym)
        CALL BLIWDH( wdot )
        CALL BDASH( 1 )

c Plot it
        CALL BLINE( XDum, YDum, Kount )
      endif

c Plot more lables
      CBuffer = IDString//' '//TIT//'$'
      call GCHARJ(0)
      call GCHAR(CBuffer,0.0,HafCsz,VSmCSz)


      CBuffer = FTime//' '//FDate//'$'
      call GCHARJ(2)
      call GCHAR(CBuffer,XRt,HafCSz,VSmCSz)

      if(Ipics .eq. 1) IDif = 'Lev1&Lev2'
      if(Ipics .eq. 2) IDif = 'Mean Trak'
      if(Ipics .eq. 3) IDif = 'Lev2-Lev1'
      if(Ipics .eq. 4) IDif = 'Lev1-Mean'
      if(Ipics .eq. 5) IDif = 'Lev2-Mean'

      CBuffer = IDif//'$'
      CALL GCHARJ(1)
      CALL GCHAR( CBuffer, XCtr, HafCSz, VSmCSz)

c Close trak plot segment
      CALL GSEGCL( 1 ) 
      call gclose

c Plotting speed and direction of primary track
c Plot if Ipics is le Pic2
      if(Ipics .gt. Pic2) go to 99

      call groute('select hposta;ex')  
      call RORIEN(1)
      call gopen
      call gsegwk(0)
 
c Open speed and direction plot segment
      CALL GSEGCR( 2 )
      XXMax = 265.0
      YYMax =  205.0

C Assign locations for components of graf

      YBot=  XShort
      YHi = YYMax - 2*YBot
      if(Ipics .eq. 1 .or. Ipics .eq. 2) then
       XWide = TRat*YHi
      else
       XWide = TRat1*YHi
      endif
      XLft = 0.5*(XXMax-XWide)
      XRt =  XLft + XWide 
      YTop = YBot + YHi
      YLR = YTop + HafCSz
      XCtr = XXMax/2.
      YHed = YLR + 1.5*BgCSz

c Select character font
       call rtxesc(-5,' ')
       call rtxfon('COMP', 1)
c      call gcharf('SOFT')
c      call gcharf('TRIP')

C Plot headers on graph

      CALL GCHARJ( 1 )
      CALL GCHAR( TITLE, XCtr, YHed, BgCSz)
      CALL GCHARJ( 0 )

      CALL GCHARJ( 0 )
      CALL GCHAR( 'Time: $' , XLft, YLR, SmCSz )
      call gnumb(T(ItStart),9999.,9999.,SmCSz,0)
      call gchar(' to $',9999.,9999.,SmCSz)     
      call gnumb(T(ItEnd),9999.,9999.,SmCSz,0)
      call gchar(' h$',9999.,9999.,SmCSz)     

      CALL GCHARJ( 2 )
      CBuffer = NJAX//'$'
      CALL GCHAR( CBuffer, XRt, YLR, SmCSz )

C Set where you want graph to be on plot
      CALL BGRAF( XLft, YBot, XWide, YHi)

C Set up t-Axis
      CALL BAXLAB( SmCSz, SmCSz, 0, 0 )
      Tstart = ANINT(T(ItStart))
      Tend = ANINT(T(ItEnd))
      if(Ipics .eq. 1 .or. Ipics .eq. 2) then
       CALL BAXIS( 1, Tstart, TInt, Tend, 't (hr) $' )
      else
       CALL BAXIS( 1, Tstart, TInt1, Tend, 't (hr) $' )
      endif

C Set up C-Axis
      CALL BAXLAB( SmCSz, SmCSz, 0, 0 )
      if(Ipics .eq. 1 .or. Ipics .eq. 2) then
       CALL BAXIS( 2, 0.0, CInt, CMax , '^223C^223 (ms>->1)$' )
      else
       CALL BAXIS( 2, 0.0, CInt1, CMax1 , '^223C^223 (ms>->1)$' )
      endif

C Set up line characteristics
      CALL BLIWDH( wsolid )
      CALL BDASH( 0 )

C Plot C vs. t

c Calculate speed
      if(Ipics .eq. 1 .or. Ipics .eq. 3 .or. Ipics .eq. 5) then
        do Ir = ItStart, ItEnd
          ARay(Ir) = sqrt(CX(Ir)**2 + CY(Ir)**2)
        enddo
      endif
      if(Ipics .eq. 2) then
        do Ir = ItStart, ItEnd
          ARay(Ir) = sqrt(CXM(Ir)**2 + CYM(Ir)**2)
        enddo
      endif
      if(Ipics .eq. 4) then
        do Ir = ItStart, ItEnd
          ARay(Ir) = sqrt(CX1(Ir)**2 + CY1(Ir)**2)
        enddo
      endif

c Move speed to dummy arrays
      call MovRays(T,ARay,XDum,YDum,ItStart,ItENd, Kount )

c Plot speed
      CALL BLINE(XDum,YDum,Kount)

C Set up direction-Axis

      call baxori(XRt,YBot)
      CALL BAXLAB( SmCSz, SmCSz, 0, 0 )
      CALL BAXIS( -2, 0.0,45.0,360.0, '^2137<C (deg)$' )


C Plot direction vs. T
      if(Ipics .eq. 1 .or. Ipics .eq. 3 .or. Ipics .eq. 5) then
         do i = 1,ItMax
           Cxt(i) = CX(i)
           Cyt(i) = CY(i)
         enddo
      endif
      if(Ipics .eq. 2) then
         do i = 1,ItMax
           Cxt(i) = CXM(i)
           Cyt(i) = CYM(i)
         enddo
      endif
      if(Ipics .eq. 4) then
         do i = 1,ItMax
           Cxt(i) = CX1(i)
           Cyt(i) = CY1(i)
         enddo
      endif
   
      k = -1
      do Ir = ItStart, ItEnd
        if((Cxt(Ir).ne.0.0).and.(Cyt(Ir).ne.0.0))then
          k = k + 1
          ARay(k) = 57.29578 * atan2(Cxt(Ir),Cyt(Ir))
          TRay(k) = T(Ir)     
        endif
        if(ARay(k).lt.0.0)ARay(k)=360.+ARay(k)
        if(k.gt.1)then
          IBreak = (ARay(k).gt.330.).and.(ARay(k-1).lt.30.)
     1         .or.(ARay(k).lt.30.).and.(ARay(k-1).gt.330.)
     2         .or.(Ir.eq.ItEnd)
        else
          IBreak = .false.
        endif
        if(IBreak)then
          CALL BLIWDH( wdot )
          CALL BDASH( 1 )
          CALL BLINE( TRay, ARay, k )
          k = -1
        endif
      enddo

      CBuffer = IDString//' '//TIT//'$'
      call GCHARJ(0)
      call GCHAR(CBuffer,XLft,HafCsz,VSmCSz)
      CBuffer = FTime//' '//FDate//'$'
      call GCHARJ(2)
      call GCHAR(CBuffer,XRt,HafCSz,VSmCSz)

      if(Ipics .eq. 1) IDif = 'Lev1&Lev2'
      if(Ipics .eq. 2) IDif = 'Mean Trak'
      if(Ipics .eq. 3) IDif = 'Lev2-Lev1'
      if(Ipics .eq. 4) IDif = 'Lev1-Mean'
      if(Ipics .eq. 5) IDif = 'Lev2-Mean'

      CBuffer = IDif//'$'
      CALL GCHARJ(1)
      CALL GCHAR( CBuffer, XCtr, HafCSz, VSmCSz)
      CALL GSEGCL( 2 )
      CALL GCLOSE

  99  continue

      enddo

      RETURN
      END


        subroutine GetParms(ItFirst,ItBegin,ItLast,ItFirst1,ItBegin1,
     1          ItLast1,NSym,XMin,XInt,XMax,YMin,YInt,YMax,
     2          XRat,CInt,CMax,TInt,TRat,TITLE,TITLE2,IPort,ITrak1,
     3          XMin1,XInt1,XMax1,YMin1,YInt1,YMax1,
     4          XRat1,CInt1,CMax1,TInt1,TRat1,Pics,Pic2)
	character TITLE*25,TITLE2*25
	logical IPort,ITrak1
	read(4,*)IPort,ITrak1
	read(4,'(A25)')TITLE
	read(4,'(A25)')TITLE2
	read(4,*)ItFirst,ItBegin,ItLast,NSym
        read(4,*)ItFirst1,ItBegin1,ItLast1
	read(4,*)XMin,XInt,XMax
	read(4,*)YMin,YInt,YMax,XRat
	read(4,*)CInt,CMax
	read(4,*)TInt,TRat
	read(4,*)XMin1,XInt1,XMax1
	read(4,*)YMin1,YInt1,YMax1,XRat1
	read(4,*)CInt1,CMax1
	read(4,*)TInt1,TRat1,Pics,Pic2
	return
	end

        subroutine MovRays(X,Y,XDum,YDum,ItFirst,ItLast,Kount)
        parameter (ItMax=230500)
        real*4 X(0:ItMax),Y(0:ItMax),XDum(0:ItMax),YDum(0:ItMax)
        Kount=0
        do It = ItFirst,ItLast
          XDum(Kount)=X(It)
          YDum(Kount)=Y(It)
          Kount=Kount+1
        enddo
        return
        end

        subroutine ReadSet(FDate,FTime,Rho)
        real*4 Rho(3)
	character FDate*9,FTime*8,Dummy*72

        read(9,'(a72)')Dummy
        read(9,'(1x,a9,1x,a8,1x,a9)')Dummy,FTime,FDate
        do i=1,15
           read(9,'(a72)')Dummy
        enddo
        read(9,'(1x,a28,1x,3g13.6)')Dummy,Rho
        write(6,*)Rho
        return
        end


